Name: cyrus-imapd
Version: 2.2.2
Release: alt3
Summary: A high-performance mail store with IMAP and POP3 support
License: CMU License
Group: System/Servers
Url: http://asg.web.cmu.edu/cyrus/imapd/
Source0: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/%name-%version-BETA.tar.gz
Source1: cyrus-procmailrc
Source2: cyrus-user-procmailrc.template
Source3: %name.logrotate
Source4: %name.imap-2.1.x-conf
Source7: %name.pam-config
Source8: %name-procmail+cyrus.mc
Source10: %name.sysconfig
Source11: %name.cvt_cyrusdb_all
Source12: %name.magic
Source13: %name.sasl-conf
Source14: %name.cron-daily
Source15: Changelog.autocreate
Source16: folderxfer
Source17: imapcreate.pl
Source18: inboxfer
Source19: %name-README.HOWTO-recover-mailboxes.db
Source20: %name-sendmail-8.12.9-cyrusv2.m4
Source21: %name.init.Sisyphus
Source22: %name.init.Master

Patch0: %name-2.0.5-mandir.patch
Patch1: %name-2.0.9-cflags.patch
Patch2: %name-2.0.12-deliverman.patch
Patch3: %name-2.0.12-cyradm_man_sec.patch
Patch4: %name-2.1.3-service_path.patch
Patch5: %name-2.1.9-fdatasync.patch
Patch6: %name-2.1.11-snmpargs.patch
Patch7: http://servercc.oakton.edu/~jwade/cyrus/cyrus-imapd-2.1.3/cyrus-imapd-2.1.3-flock.patch
Patch8: %name-alt-header8bit.patch
#Patch8: %name-2.1.14-munge8bit.patch
Patch9: %name-alt-cyradm.patch
Patch10: %name-alt-db4.patch
Patch11: %name-2.2.2-BETA-autocreate-0.8.3.diff
Patch12: %name-2.2.2-idled.patch

PreReq: e2fsprogs, /sbin/chkconfig, /sbin/service
Provides: imap
Obsoletes: imap

%define uid 76
%define _cyrususer cyrus
%define _cyrusgroup mail
%define _vardata %_var/lib/imap
%define _spooldata %_var/spool/imap
%define _cyrexecdir %_libdir/cyrus
%define _confdir master/conf
%define _contribdir %_datadir/%name/contrib
%define _cyrusconf %_confdir/prefork.conf

Requires: libsasl2-plugin-gssapi

# handle initscript style change
%define dist_tag %nil

%if_with Master
%define dist_tag Master
%endif

%if_with Sisyphus
%define dist_tag Sisyphus
%endif

%if "%dist_tag" == ""
%define dist_tag %(cut -d" " -f3 < /etc/altlinux-release)
%endif

# Automatically added by buildreq on Wed May 21 2003
BuildRequires: flex  libe2fs-devel libsasl2-devel
BuildRequires: libssl-devel perl-devel
%if "%dist_tag" == "Sisyphus"
BuildRequires: pam0-config libpam0-devel libdb4.0-devel
%else
BuildRequires: pam-config libpam-devel libdb4-devel
%endif

%description
The %name package contains the core of the Cyrus IMAP server.
It is a scaleable enterprise mail system designed for use from
small to large enterprise environments using standards-based
internet mail technologies.

A full Cyrus IMAP implementation allows a seamless mail and bulletin
board environment to be set up across multiple servers. It differs from
other IMAP server implementations in that it is run on "sealed"
servers, where users are not normally permitted to log in. The mailbox
database is stored in parts of the filesystem that are private to the
Cyrus IMAP server. All user access to mail is through software using
the IMAP, POP3, or KPOP protocols. TLSv1 and SSL are supported for
security.

%package murder
Group: System/Servers
Summary: Cyrus IMAP server murder aggregator system files
Requires: %name = %version-%release

%description murder
The %name-murder package contains the Cyrus murder aggregator system,
i.e. IMAP, POP3 and LMTP proxies, and the mupdate mailbox master daemon.
It allows for cluster setups where there are many backend Cyrus spools
and frontend proxy servers.

%package devel
Group: Development/C
Summary: Cyrus IMAP server development files
#Requires: %name = %version-%release

%description devel
The %name-devel package contains header files and libraries
necessary for developing applications which use the imclient library.

%package -n perl-Cyrus
Group: Development/Perl
Summary: Cyrus IMAP server utility Perl modules
Provides: perl(Cyrus/IMAP.pm) perl(Cyrus/IMAP/Admin.pm)

%description -n perl-Cyrus
The perl-Cyrus package contains Perl modules necessary to use the
Cyrus IMAP server administration utilities.

%package utils
Group: System/Servers
Summary: Cyrus IMAP server administration utilities
Requires: perl-Cyrus = %version-%release

%description utils
The %name-utils package contains administrative tools for the
Cyrus IMAP server. It can be installed on systems other than the
one running the server.

%package doc
Group: System/Servers
Summary: Cyrus IMAP server documentation

%description doc
The %name-doc package contains Here the documentation about
Cyrus IMAP server.

%prep
%setup -q -n %name-%version-BETA

%patch0 -p1 -b .mandir
%patch1 -p1 -b .cflags
%patch2 -p1 -b .deliverman
%patch3 -p1
%patch4 -p0 -b .service_path
%patch5 -p0 -b .fdatasync
%patch6 -p1 -b .snmpargs
%patch7 -p1 -b .flock
%patch8 -p1 -b .8bit
%patch9 -p1 -b .cyradm
%patch10 -p1 -b .db4
%patch11 -p1 -b .autocreate
%patch12 -p2 -b .idled

%build
# kerberos include is needed (because of openssl-0.9.7 ?)
CPPFLAGS="-I%_includedir/et -I%prefix/include/krb5"
export CPPFLAGS
CFLAGS="$RPM_OPT_FLAGS -fPIC"
export CFLAGS

pushd makedepend
./configure
%__make
popd

%configure \
  --enable-netscapehack \
  --enable-listext \
  --enable-nntp \
  --enable-murder \
  --without-ucdsnmp \
  --with-perl=%__perl \
  --with-libwrap=%prefix \
  --with-cyrus-prefix=%_cyrexecdir \
  --with-cyrus-user=%_cyrususer \
  --with-cyrus-group=%_cyrusgroup \
  --with-auth=unix \
  --with-idle=idled \
  --with-bdb-incdir=%_includedir/db4
#  --with-krb=%prefix/lib/krb5

%__make

# Modify docs master --> cyrus-master
pushd man
  %__perl -pi -e "s@master\(8\)@cyrus-master(8)@" `ls *5 *8`
popd
pushd doc
  %__perl -pi -e "s@master@cyrus-master@g;" man.html
popd
pushd doc/man
  %__perl -pi -e "s@master\(8\)@cyrus-master(8)@;" `ls *html`
popd

# Modify path in perl scripts
%__perl -pi -e "s@/usr/local/bin/perl@%__perl@" `find . -type f -name "*.pl"`

# Cleanup of doc dir
find doc perl -name CVS -type d | xargs -r rm -fr
find doc -name "*~" -type f | xargs -r rm -f
%__rm -f doc/Makefile.dist
%__rm -f doc/text/htmlstrip.c

# modify lmtp socket path in .conf files
%__perl -pi -e "s@/var/imap@%_vardata@" %_confdir/*.conf

%install
# Do what the regular make install does
%if "%dist_tag" == "Master"
    %__make install DESTDIR=%buildroot PREFIX=%buildroot%prefix \
					mandir=%_mandir INSTALLDIRS=vendor
    %__make -C man install DESTDIR=%buildroot PREFIX=%buildroot%prefix \
							    mandir=%_mandir
%else
    %__make install DESTDIR=%buildroot PREFIX=%prefix mandir=%_mandir \
							INSTALLDIRS=vendor
    %__make -C man install DESTDIR=%buildroot PREFIX=%prefix mandir=%_mandir
%endif

%__install -m 755 imtest/imtest	%buildroot%_cyrexecdir/
%__install -m 755 perl/imap/cyradm	%buildroot%_cyrexecdir/

# Install tools
for tool in tools/* ; do
  test -f ${tool} && %__install -m 755 ${tool} %buildroot%_cyrexecdir/
done

# Create directories
%__install -d \
  %buildroot%_sysconfdir/{rc.d/init.d,logrotate.d,pam.d,sysconfig,cron.daily} \
  %buildroot%_libdir/sasl2 \
  %buildroot%_bindir \
  %buildroot%_spooldata/stage. \
  %buildroot%_vardata/{user,quota,proc,log,msg,socket,db,sieve,rpm,backup} \
  %buildroot%_contribdir \
  %buildroot%_datadir/%name/rpm

# Install additional files
%__install -m 755 %SOURCE11   %buildroot%_cyrexecdir/cvt_cyrusdb_all
%__install -m 755 %SOURCE12   %buildroot%_datadir/%name/rpm/magic

# Install config files
%__install -m 644 %_cyrusconf %buildroot%_sysconfdir/cyrus.conf
%__install -m 644 %SOURCE4    %buildroot%_sysconfdir/imapd.conf
%__install -m 644 %SOURCE7    %buildroot%_sysconfdir/pam.d/pop
%__install -m 644 %SOURCE7    %buildroot%_sysconfdir/pam.d/imap
%__install -m 644 %SOURCE7    %buildroot%_sysconfdir/pam.d/sieve
%__install -m 644 %SOURCE7    %buildroot%_sysconfdir/pam.d/mupdate
%__install -m 644 %SOURCE7    %buildroot%_sysconfdir/pam.d/lmtp
%__install -m 644 %SOURCE10   %buildroot%_sysconfdir/sysconfig/%name

# install the init script

%if "%dist_tag" == "Master"
%__install -m755 %SOURCE22 \
	%buildroot%_initdir/%name
%else
%__install -m755 %SOURCE21 \
	%buildroot%_initdir/%name
%endif

%__install -m 644 %SOURCE3    %buildroot%_sysconfdir/logrotate.d/%name
%__install -m 755 %SOURCE14   %buildroot%_sysconfdir/cron.daily/%name
%__install -m 600 %SOURCE13   %buildroot%_libdir/sasl2/Cyrus.conf

# Install templates
%__install -m 755 -d doc/conf
%__install -m 644 %_confdir/*.conf doc/conf/

# Install contribs
%__install -m 755 %SOURCE16 %SOURCE17 %SOURCE18  %buildroot%_contribdir
%__install -m 644 %SOURCE19 %SOURCE15 %SOURCE20 doc/

# Put binaries in place according to FHS
mv -f %buildroot%_cyrexecdir/bin/*	%buildroot%_cyrexecdir/
rm -rf %buildroot%_cyrexecdir/bin

# Rename 'master' binary and manpage to avoid crash with postfix
mv -f %buildroot%_cyrexecdir/master	%buildroot%_cyrexecdir/cyrus-master
mv -f %buildroot%_mandir/man8/master.8 %buildroot%_mandir/man8/cyrus-master.8
mv -f doc/man/master.8.html doc/man/cyrus-master.8.html

# Create symlinks
ln -sf ../lib/cyrus/cyradm %buildroot%_bindir/
ln -sf ../lib/cyrus/imtest %buildroot%_bindir/

# Create filelist for perl package, compress manpages before
[ -x /usr/lib/rpm/brp-compress ] && /usr/lib/rpm/brp-compress
find %buildroot%perl_vendor_autolib/Cyrus %buildroot%perl_vendor_archlib/Cyrus -type f -print |
  sed "s@^%buildroot@@g" |
  grep -v perllocal.pod |
  grep -v "\.bs" |
  grep -v "\.packlist" > perl-Cyrus-%version-filelist
find %buildroot%perl_vendor_man3dir -type f -name "Cyrus*" -print |
  sed "s@^%buildroot@@g" >> perl-Cyrus-%version-filelist
if [ "$(cat perl-Cyrus-%version-filelist)X" = "X" ] ; then
  echo "ERROR: EMPTY FILE LIST"
  exit -1
fi

# Remove installed but not packaged files
rm -f %buildroot%_cyrexecdir/not-mkdep
find %buildroot -name "perllocal.pod" -exec rm -f {} \;
find %buildroot -name ".packlist" -exec rm -f {} \;

# Create file wich contains information about compiled db backends
for conf in DUPLICATE MBOX SEEN SUBS TLS; do
  echo CONFIG_DB_${conf}=$(grep "CONFIG_DB_${conf}" config.h | sed -e 's/)//' -e 's/_/-/g' | cut -d" " -f3 | cut -d"-" -f2) >> %buildroot%_datadir/%name/rpm/db.cfg
done


%pre
# Create 'cyrus' user on target host
/usr/sbin/useradd -c "Cyrus IMAP Server" -d %_vardata -g %_cyrusgroup \
  -s /bin/bash -u %uid -r %_cyrususer 2> /dev/null || :
# Let postun know whether cyrus-imapd was running
if [ -e /var/lock/subsys/cyrus-imapd ]; then
  /sbin/service %name stop >/dev/null 2>&1 || :
  touch /var/lock/subsys/cyrus-imapd
fi

%post
/sbin/chkconfig --add %name

if [ -f /var/lock/subsys/cyrus-imapd ]
then
    /sbin/service %name restart
fi

## Create SSL certificates
#exec > /dev/null 2> /dev/null
#if [ ! -f %_datadir/ssl/certs/%name.pem ]; then
#pushd %_datadir/ssl/certs
#umask 077
#cat << EOF | make %name.pem
#--
#Irkutsk Area
#Ust-Ilimsk
#Telnet
#Telnet
#mail.ilimnet.ru
#root@ilimnet.ru
#EOF
#chown root.%_cyrusgroup %name.pem
#chmod 640 %name.pem
#popd
#fi

# Force synchronous updates, usually only on ext2 filesystems
for i in %_vardata/{user,quota} %_spooldata
do
  if [ `find $i -maxdepth 0 -printf %%F` = "ext2" ]; then
    chattr -R +S $i 2>/dev/null
  fi
done

# Add service entries if necessary
if ! grep -q ^lmtp %_sysconfdir/services; then
  echo -e 'lmtp\t\t24/tcp\t\t\t\t# LMTP Mail Delivery over TCP' >> %_sysconfdir/services
  echo -e 'lmtp\t\t24/udp\t\t\t\t# LMTP Mail Delivery over TCP' >> %_sysconfdir/services
fi
if ! grep -q ^pop3s %_sysconfdir/services; then
  echo -e 'pop3s\t\t995/tcp\t\t\t\t# POP-3 over SSL' >> %_sysconfdir/services
  echo -e 'pop3s\t\t995/udp\t\t\t\t# POP-3 over SSL' >> %_sysconfdir/services
fi
if ! grep -q ^imaps %_sysconfdir/services; then
  echo -e 'imaps\t\t993/tcp\t\t\t\t# IMAP over SSL' >> %_sysconfdir/services
  echo -e 'imaps\t\t993/udp\t\t\t\t# IMAP over SSL' >> %_sysconfdir/services
fi
if ! grep -q ^sieve %_sysconfdir/services; then
  echo -e 'sieve\t\t2000/tcp\t\t\t# Sieve Mail Filter Daemon' >> %_sysconfdir/services
  echo -e 'sieve\t\t2000/udp\t\t\t# Sieve Mail Filter Daemon' >> %_sysconfdir/services
fi

%preun
if [ $1 = 0 ]; then
  /sbin/service %name stop >/dev/null 2>&1 || :
  /sbin/chkconfig --del %name
  rm -f %_vardata/socket/lmtp 2> /dev/null
fi

%postun
if [ $1 = 0 ]; then
  /usr/sbin/userdel %_cyrususer 2> /dev/null || :
else
  /sbin/service %name condrestart >/dev/null 2>&1 || :
fi

%files
%defattr(0644,root,root,0755)
%config(noreplace) %_sysconfdir/cyrus.conf
%config(noreplace) %_sysconfdir/imapd.conf
%attr(0755,root,root) %config %_initdir/%name
%config %_sysconfdir/logrotate.d/%name
%config(noreplace) %_sysconfdir/sysconfig/%name
%config(noreplace) %verify(not size,not md5) %_sysconfdir/pam.d/imap
%config(noreplace) %verify(not size,not md5) %_sysconfdir/pam.d/lmtp
%config(noreplace) %verify(not size,not md5) %_sysconfdir/pam.d/pop
%config(noreplace) %verify(not size,not md5) %_sysconfdir/pam.d/sieve
%config(noreplace) %attr(600,%_cyrususer,%_cyrusgroup) %_libdir/sasl2/Cyrus.conf
%attr(0755,root,root) %config %_sysconfdir/cron.daily/%name
%dir %_cyrexecdir
%attr(4710,%_cyrususer,%_cyrusgroup) %_cyrexecdir/deliver
%attr(0755,root,root) %_cyrexecdir/arbitron
%attr(0755,root,root) %_cyrexecdir/chk_cyrus
%attr(0755,root,root) %_cyrexecdir/sievec
%attr(0755,root,root) %_cyrexecdir/ctl_cyrusdb
%attr(0755,root,root) %_cyrexecdir/ctl_deliver
%attr(0755,root,root) %_cyrexecdir/ctl_mboxlist
%attr(0755,root,root) %_cyrexecdir/cvt_cyrusdb
%attr(0755,root,root) %_cyrexecdir/cvt_cyrusdb_all
%attr(0755,root,root) %_cyrexecdir/cyrdump
%attr(0755,root,root) %_cyrexecdir/cyr_expire
%attr(0755,root,root) %_cyrexecdir/cyrus-master
%attr(0755,root,root) %_cyrexecdir/dohash
%attr(0755,root,root) %_cyrexecdir/fetchnews
%attr(0755,root,root) %_cyrexecdir/fud
%attr(0755,root,root) %_cyrexecdir/idled
%attr(0755,root,root) %_cyrexecdir/imapd
%attr(0755,root,root) %_cyrexecdir/ipurge
%attr(0755,root,root) %_cyrexecdir/lmtpd
%attr(0755,root,root) %_cyrexecdir/mbexamine
%attr(0755,root,root) %_cyrexecdir/mbpath
%attr(0755,root,root) %_cyrexecdir/mkimap
%attr(0755,root,root) %_cyrexecdir/nntpd
%attr(0755,root,root) %_cyrexecdir/notifyd
%attr(0755,root,root) %_cyrexecdir/pop3d
%attr(0755,root,root) %_cyrexecdir/quota
%attr(0755,root,root) %_cyrexecdir/reconstruct
%attr(0755,root,root) %_cyrexecdir/rehash
%attr(0755,root,root) %_cyrexecdir/squatter
%attr(0755,root,root) %_cyrexecdir/timsieved
%attr(0755,root,root) %_cyrexecdir/tls_prune
%attr(0755,root,root) %_cyrexecdir/translatesieve
%attr(0755,root,root) %_cyrexecdir/undohash
%attr(0755,root,root) %_cyrexecdir/upgradesieve
%attr(0750,%_cyrususer,%_cyrusgroup) %dir %_vardata
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/user
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/quota
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/proc
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/log
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/msg
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/socket
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/db
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/sieve
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/rpm
%attr(0750,%_cyrususer,%_cyrusgroup) %_vardata/backup
%attr(0750,%_cyrususer,%_cyrusgroup) %dir %_spooldata
%attr(0750,%_cyrususer,%_cyrusgroup) %_spooldata/*
%dir %_datadir/%name
%dir %_datadir/%name/rpm
%_datadir/%name/rpm/*
%_mandir/man5/*
%_mandir/man8/*

%files doc
%doc COPYRIGHT README README.autocreate
%doc $RPM_SOURCE_DIR/cyrus-procmailrc
%doc $RPM_SOURCE_DIR/cyrus-user-procmailrc.template
%doc $RPM_SOURCE_DIR/%name-procmail+cyrus.mc
%doc doc/*

%files murder
%config(noreplace) %verify(not size,not md5) %_sysconfdir/pam.d/mupdate
%attr(0755,root,root) %_cyrexecdir/lmtpproxyd
%attr(0755,root,root) %_cyrexecdir/mupdate
%attr(0755,root,root) %_cyrexecdir/pop3proxyd
%attr(0755,root,root) %_cyrexecdir/proxyd

%files devel
%defattr(0644,root,root,0755)
%_includedir/cyrus
%_libdir/lib*.a
%_mandir/man3/*

%files -n perl-Cyrus
%perl_vendor_autolib/Cyrus*
%perl_vendor_archlib/Cyrus*
%doc perl/imap/README
%doc perl/imap/Changes
%doc perl/imap/examples

%files utils
%defattr(0644,root,root,0755)
%attr(0755,root,root) %_cyrexecdir/arbitronsort.pl
%attr(0755,root,root) %_cyrexecdir/cyradm
%attr(0755,root,root) %_cyrexecdir/imtest
%attr(0755,root,root) %_cyrexecdir/mupdate-loadgen.pl
%attr(0755,root,root) %_cyrexecdir/convert-sieve.pl
%attr(0755,root,root) %_cyrexecdir/mknewsgroups
%attr(0755,root,root) %_cyrexecdir/config2header
%attr(0755,root,root) %_cyrexecdir/config2man
%attr(0755,root,root) %_cyrexecdir/masssievec
%attr(0755,root,root) %_contribdir
%attr(0755,root,root) %_bindir/*
%_mandir/man1/*

%changelog
* Fri Nov 28 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.2-alt3
- Enable `idle' daemon
- Update autocreate patch to 0.8.3
+ Add cyrus-imapd-2.2.2-idled.patch (fix idled compile)

* Mon Nov 03 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.2-alt2
- fix cyrus-imapd-alt-cyradm.patch (error:
  /usr/bin/cyradm: line 46: `exec perl -MCyrus::IMAP::Shell -e shell -- "$@" ;;')

* Wed Oct 29 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.2-alt1
- 2.2.2
- Disable `idle' daemon

* Sat Sep 13 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.1-alt6
- implemented autodetected / manual distro setting to package initscripts
  for both ALM2.2 (maintenance builds) and Sisyphus (implementation based
  somewhat on aureal-std-up.spec by Alexey Morozov <morozov novosoft ru>)

* Sun Aug 24 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.1-alt5
- removed creation of spool/config dirs, not needed anymore
- add sendmail m4 macro
- just one source for pam default configuration (they were all the same)
- added /etc/pam.d/lmtp
- added murder support

* Tue Aug 05 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.1-alt4
- Fixed definitions of files in perl-Cyrus

* Mon Aug 04 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.1-alt3
- fixed pam0(system-auth) requires

* Mon Aug 04 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.1-alt2
- by ivv:
    + changed main group to System/Servers
    + changed group of perl-Cyrus to Development/Perl
    + changed group of cyrus-imap-utils to System/Servers
    + changed file permissions on /usr/lib/cyrus/deliver to 4710
    + added patch for autocreate mailbox on post or login (see
      email.uoa.gr/autocreate)
    + added some contrib utils - folderxfer,imapcreate.pl,inboxfer

* Fri Jul 25 2003 Alexei Takaseev <taf@altlinux.ru> 2.2.1-alt1
- first build for ALT
